<template>
    <v-row>
        <v-col class="py-0 my-0" cols="12">
            <SystemBar
                :calendarTitle="calendarTitle"
                :stepType="calendar.stepType"
                @prev="prev"
                @next="next"
            />
        </v-col>
        <v-col class="pa-4 mt-5 mb-5" cols="12">
            <Chart
                ref="chart"
                :state="state"
                :range="calendar.range"
                :receipts="calendar.receipts" />
        </v-col>
        <v-col
            class="pa-4 m-1"
            v-for="(user, index) in users"
            :key="index"
            cols="6">
            <v-card elevation="4">
                <v-card-title>
                    {{ user.name }}
                </v-card-title>
                <v-card-text>
                    {{ formatAmount(state.total / users.length) }}
                </v-card-text>
            </v-card>
        </v-col>
    </v-row>
</template>

<script lang="ts">
import { Component, Inject, Vue } from 'vue-property-decorator'
import { Observer } from 'mobx-vue';
import { CalendarModel } from "@/store/modules/calendar";
import Chart from "@/components/Chart.vue"
import Header from "@/components/Header.vue"
import { ChartModel } from "@/store/modules/chart"
import { UserModel } from '@/store/modules/user';
import { formatAmount } from "@/utils/price"
import { RootStore } from "@/store"
import SystemBar from "@/components/SystemBar.vue";

@Observer
@Component({
    components: {
        Chart,
        Header,
        SystemBar
    }
})
export default class Overview extends Vue {

    @Inject("calendarModel") calendar!: CalendarModel
    @Inject("userModel") userModel!: UserModel
    @Inject("root") root !: RootStore

    private state = new ChartModel()
    private stepType: string = "month"

    private formatAmount(price: number) {
        return formatAmount(price);
    }

    private get calendarTitle() {
        return "家計簿";
    }

    private get users() {
        return this.userModel.users;
    }

    private prev() {
        this.calendar.changeRange(-1);
    }

    private next() {
        this.calendar.changeRange(+1);
    }
}
</script>
